/*
 * Lehrstuhl Softwaretechnologie, TU Dresden, Datei Bibliothek.java
 *
 * Bibliothek-Klasse implementiert eine einfache Bibliothek, die Bcher sortiert
 * in eine Liste aufnehmen und auf Existenz von Bchern mittels zweier Kriterien
 * prfen kann
 */

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

public class Bibliothek {

    // bestand muss auf List spezialisiert werden wegen Anwendung
    // der Klasse Collections und des indizierten Zugriffs auf bestand
    private List<Buch> bestand;

    public Bibliothek() {
        bestand = new ArrayList<Buch>();
        // oder
        // bestand = new LinkedList<Buch>();
    }

    // Sortierung nach der ISBN
    public boolean sortiertesEinfuegen(Buch neuesBuch) {
        bestand.add(neuesBuch);
        Collections.sort(bestand);
        return true;

    }

    public Buch sucheNachISBN(String isbn) {
        //binre Suche in einer sortierten Liste
        //unter Nutzung der statischen Klasse Collections
        int index = Collections.binarySearch(bestand, new Buch(isbn));
        if (index < 0) {
            return null;
        } else {
            return bestand.get(index);
        }
    }

    public Collection<Buch> sucheNachAutor(String autor) {
        // sequentielle Suche im Buchbestand
        Collection<Buch> suchergebnis = new ArrayList<Buch>();
        for (int i = 0; i < bestand.size(); i++) {
            if (autor.equals((bestand.get(i)).getAutor())) {
                suchergebnis.add(bestand.get(i));
            }
        }
        return suchergebnis;
    }
}
