/*
 * Lehrstuhl Softwaretechnologie, TU Dresden, Datei Bibliothek.java
 *
 * Bibliothek-Klasse implementiert eine einfache Bibliothek, die Bcher sortiert
 * in ein Set aufnehmen, auf Existenz von Bchern prfen und den Bestand nach
 * Autoren auflisten kann  (Variante mit Generics)
 */

import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;

public class Bibliothek {

    private Map<String, Set<Buch>> bestand;

    public Bibliothek() {
        bestand = new TreeMap<String,Set<Buch>>();
    }
  
    public boolean sortiertesEinfuegen(Buch neuesBuch) {
    	String autor = neuesBuch.getAutor();
    	Set <Buch> buecherEinesAutors = sucheNachAutor(autor);
    	if (buecherEinesAutors == null) {
    		buecherEinesAutors = new TreeSet<Buch>();
            bestand.put(autor, buecherEinesAutors);   		
    	}
    	return buecherEinesAutors.add(neuesBuch);
    }

    public Buch sucheNachISBN(String isbn) {
    	for (Set<Buch> set : bestand.values()) {
    		for (Buch b: set)
            if (isbn.equals(b.getIsbn())) {
                return b;
            }
        }
        return null;
    }

    public Set<Buch> sucheNachAutor(String autor) {
       return bestand.get(autor); 
    }

    public Map<String,Set<Buch>> bestandNachAutorAuflisten() {
        return bestand;
    }

    public Set<Buch> getBestand() {
    	Set<Buch> ergebnis = new TreeSet<Buch> ();
    	for (Set<Buch> set : bestand.values()) {
    		for (Buch b: set) {
    			ergebnis.add(b);
    		}
        }
    	return ergebnis;
    }
}