/*
 * Lehrstuhl Softwaretechnologie, TU Dresden, Datei Buch.java
 *
 * Buch-Klasse implementiert ein Buch, welches mit anderen Bchern vergleichbar
 * sein soll ber die ISBN
 */

public class Buch implements Comparable<Buch> {

	private String isbn = " ";

    private String autor = " ";

    private String titel = " ";

    public Buch(String isbn, String autor, String titel) {
        this.isbn = isbn;
        this.autor = autor;
        this.titel = titel;
    }

    public Buch(String isbn) {
        // Konstruktor fr Hilfsobjekte zum Vergleichen von Bchern
        this.isbn = isbn;
    }

    public int compareTo(Buch b) {
        return isbn.compareTo(b.isbn);
    }

    public String getIsbn() {
        return isbn;
    }

    public String getAutor() {
        return autor;
    }

    public String toString() {
        return "ISBN: " + isbn + ", Autor: " + autor + ", Titel: " + titel;
    }
    
    public boolean equals(Object b){
    	return isbn.equals(((Buch)b).getIsbn());
    }
    
    public int hashCode() {
    	return isbn.hashCode();
    }
}